﻿Imports System.ServiceModel
Imports AddressBookData

' メモ: コンテキスト メニューの [名前の変更] コマンドを使用すると、コード、svc、および config ファイルで同時にクラス名 "AddressBookService" を変更できます。
Public Class AddressBookService
    Implements IAddressBookService

    <OperationContract()>
    Public Function GetEntries() As List(Of Entry)
        Using container As New AddressBookContainer()
            Return container.Entries.ToList()
        End Using
    End Function

    <OperationContract()>
    Public Function UpdateEntries(ByVal entries As IEnumerable(Of Entry)) As Boolean

        Using container As New AddressBookContainer()
            Try
                For Each entry In entries
                    container.Entries.ApplyChanges(entry)
                Next

                container.SaveChanges()
                Return True

            Catch ex As System.Data.OptimisticConcurrencyException
                Return False

            End Try

        End Using
    End Function

    Public Sub DoWork() Implements IAddressBookService.DoWork
    End Sub

End Class
